SystemOrganization addCategory: #'CS528-SkeetManager'!

TestCase subclass: #EventTestCase
	instanceVariableNames: 'event renk henry varney jenny tom1 tom2 tony randy paul greg'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!EventTestCase methodsFor: 'running' stamp: 'HenryDuwe 7/9/2013 15:59'!
setUp

	"Create an Event"
	| eventType |
	Transcript show: 'blah'.
	eventType := Gauge12 new.
	event := Event newEventWithName: '12 Ga Event' andType: eventType.
	
  	"Create some Shooters"
	"renk := Shooter newShooterFirst: 'Jeff' middle: '' last: 'Renk'.
	renk addConcurrent: SeniorConcurrent new.
	renk setClass: (CClass new) forEvent: (Gauge12 new) withAverage: 0.9000.
	
	henry := Shooter newShooterFirst: 'Henry' middle: 'John' last: 'Duwe'.
	henry addConcurrent: TripleSubSeniorConcurrent new.
	henry setClass: (AClass new) forEvent: (Gauge12 new) withAverage: 0.9600.
	
	varney := Shooter newShooterFirst: 'Jeff' middle: '' last: 'Varney'.
	varney addConcurrent: TripleSubSeniorConcurrent new.
	varney setClass: (AClass new) forEvent: (Gauge12 new) withAverage: 0.9600.
	
	jenny := Shooter newShooterFirst: 'Jenny' middle: '' last: 'Notstad'.
	jenny addConcurrent: TripleSubSeniorConcurrent new.
	jenny addConcurrent: LadyConcurrent new.
	jenny setClass: (CClass new) forEvent: (Gauge12 new) withAverage: 0.9000.
	
	tom1 := Shooter newShooterFirst: 'Tom' middle: '' last: 'McDaniels'.
	tom1 addConcurrent: SeniorConcurrent new.
	tom1 setClass: (DClass new) forEvent: (Gauge12 new) withAverage: 0.8900.
	
	tom2 := Shooter newShooterFirst: 'Tom' middle: '' last: 'Steinbeck'.
	tom2 addConcurrent: SeniorConcurrent new.
	tom2 setClass: (BClass new) forEvent: (Gauge12 new) withAverage: 0.9100.
	
	tony := Shooter newShooterFirst: 'Tony' middle: '' last: 'Pavelka'.
	tony addConcurrent: SubSeniorConcurrent new.
	tony setClass: (EClass new) forEvent: (Gauge12 new) withAverage: 0.8500.
	
	randy := Shooter newShooterFirst: 'Randy' middle: '' last: 'Riehle'. 
	randy addConcurrent: SeniorConcurrent new.
	randy setClass: (AClass new) forEvent: (Gauge12 new) withAverage: 0.9650.

	paul := Shooter newShooterFirst: 'Paul' middle: 'David' last: 'Friesen'.
	paul addConcurrent: SeniorConcurrent new.
	paul setClass: (AClass new) forEvent: (Gauge12 new) withAverage: 0.9590.
	
	greg := Shooter newShooterFirst: 'Greg' middle: '' last: 'Schweppe'.
	greg addConcurrent: SeniorConcurrent new.
	greg setClass: (AClass new) forEvent: (Gauge12 new) withAverage: 0.9540."
	
	"Add them to Event"
	"event addShooter: renk.
	event addShooter: henry.
	event addShooter: varney.
	event addShooter: jenny.
	event addShooter: tom1.
	event addShooter: tom2.
	event addShooter: tony.
	event addShooter: randy.
	event addShooter: paul.
	event addShooter: greg."! !

!EventTestCase methodsFor: 'testing' stamp: 'HenryDuwe 7/9/2013 16:00'!
testRanking
	"| honors theAHonor |"
	
	"Enter scores"
	| honors theAHonor |
	"event setScore: { 24 . 24 . 24 . 25 } for: randy.
	event setScore: { 24 . 24 . 24 . 24 } for: varney.
	event setScore: { 22 . 24 . 25 . 25 } for: henry.
	event setScore: { 23 . 24 . 23 . 25 } for: greg.
	event setScore: { 20 . 24 . 24 . 24 } for: paul.
	event setScore: { 23 . 22 . 23 . 22 } for: renk.
	event setScore: { 22 . 23 . 22 . 23 } for: jenny.
	event setScore: { 21 . 24 . 20 . 22 } for: tom1.
	event setScore: { 24 . 22 . 21 . 21 } for: tony."
	
	"Create honors and rank"
	"honors := event honors."
	
	"Test A Class rankings"
	"theAHonor := honors select: [ :each | each type = (AClass new) ].
	self assert: (((theAHonor rankings) at: 1) == henry).
	self assert: (((theAHonor rankings) at: 1) == greg)."
	self assert: true.! !

TestCase subclass: #ShootTestCase
	instanceVariableNames: 'shoot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ShootTestCase commentStamp: '<historical>' prior: 0!
A ShootTestCase tests the skeet shoot manager application in all its various ways. It includes large-scale real tests for shoots.!

!ShootTestCase methodsFor: 'running' stamp: 'HenryDuwe 7/5/2013 13:24'!
setUp 	

	! !

!ShootTestCase methodsFor: 'testing' stamp: 'HenryDuwe 7/5/2013 13:23'!
testAddShooter
	shoot addShooter: (Shooter newNSSANum: '153783').
	! !

!ShootTestCase methodsFor: 'testing' stamp: 'HenryDuwe 7/8/2013 13:19'!
testMikeKipp
	| shootoffs12 event12 eventDoubles event28 event410 henry paul renk varney jenny tom1 tom2 tony randy |
	"Setup shoot."
	shoot := Shoot newNamed: 'Mike Kipp 2013'.
	eventDoubles := RealEvent newOf: (EventType newDoubles) named: 'Doubles Event'.
	shoot addEvent: (eventDoubles).
	event12 := RealEvent newOf: (EventType new12ga) named: '12ga Event'.
	shoot addEvent: (event12).
	event28 := RealEvent newOf: (EventType new28ga) named: '28ga Event'.
	shoot addEvent: (event28).
	event410 := RealEvent newOf: (EventType new410bore) named: '410bore Event'.
	shoot addEvent: (event410).
	shoot addEvent: (CompositeEvent newWith: {event12 . event28 . event410 . eventDoubles} named: 'HOA Event').
			
	"Add shooters"
	henry := Shooter newNamed: 'Henry Duwe'.
	shoot addShooter: henry.
	paul := Shooter newNamed: 'Paul Friesen'.
	shoot addShooter: henry.
	renk := Shooter newNamed: 'Jeff Renk'.
	varney := Shooter newNamed: 'Jeff Varney'.
	jenny := Shooter newNamed: 'Jenny Notstad'.
	tom1 := Shooter newNamed: 'Tom McDaniels'.
	tom2 := Shooter newNamed: 'Tom Steinbeck'.
	tony := Shooter newNamed: 'Tony Pavelka'.
	randy := Shooter newNamed: 'Randy Riehle'.
	
	
	"Enter scores"
	shoot enterScores: #(#22 #24 #25 #25) for: (henry) in: event12.
	
	"Print scores by class and concurrent"
	
	"Determine shootoffs"
	shootoffs12 := shoot determineShootoffsFor: event12.
	
	self assert: (shootoffs12 size > 0).

	"Resolve ties"
	
	
	"Print winners"
	Transcript show: (shoot winners).
! !

Object subclass: #ClassType
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ClassType commentStamp: '<historical>' prior: 0!
a class to hold class types.
!

ClassType subclass: #AAAClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

AAAClass class
	instanceVariableNames: 'uniqueInstance'!

AAAClass class
	instanceVariableNames: 'uniqueInstance'!

!AAAClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:48'!
new
     uniqueInstance ifNil: [uniqueInstance := super new name:'AAAClass' ]. 
     ^ uniqueInstance.! !

!AAAClass methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/8/2013 13:59'!
name: aName 
	name := aName.
	! !

ClassType subclass: #AAClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

AAClass class
	instanceVariableNames: 'uniqueInstance'!

AAClass class
	instanceVariableNames: 'uniqueInstance'!

!AAClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:48'!
new
     uniqueInstance ifNil: [uniqueInstance := super new name:'AAClass' ]. 
     ^ uniqueInstance.! !

!AAClass methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/8/2013 13:59'!
name: aName 
	name := aName.
	! !

ClassType subclass: #AClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

AClass class
	instanceVariableNames: 'uniqueInstance'!

AClass class
	instanceVariableNames: 'uniqueInstance'!

!AClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:48'!
new
     uniqueInstance ifNil: [uniqueInstance := super new name:'AClass' ]. 
     ^ uniqueInstance.! !

!AClass methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/8/2013 14:00'!
name: aName 
	name := aName.
	! !

ClassType subclass: #BClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

BClass class
	instanceVariableNames: 'uniqueInstance'!

BClass class
	instanceVariableNames: 'uniqueInstance'!

!BClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:48'!
new
     uniqueInstance ifNil: [uniqueInstance := super new name:'BClass' ]. 
     ^ uniqueInstance.! !

!BClass methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/8/2013 14:01'!
name: aName 
	name := aName.
	! !

ClassType subclass: #CClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

CClass class
	instanceVariableNames: 'uniqueInstance'!

CClass class
	instanceVariableNames: 'uniqueInstance'!

!CClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:48'!
new
     uniqueInstance ifNil: [uniqueInstance := super new name:'CClass' ]. 
     ^ uniqueInstance.! !

!CClass methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/8/2013 14:01'!
name: aName 
	name := aName.
	! !

!ClassType methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 20:07'!
average 
	^ average.! !

!ClassType methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 20:07'!
name
	^ name.! !

ClassType subclass: #DClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

DClass class
	instanceVariableNames: 'uniqueInstance'!

DClass class
	instanceVariableNames: 'uniqueInstance'!

!DClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:48'!
new
     uniqueInstance ifNil: [uniqueInstance := super new name:'CClass' ]. 
     ^ uniqueInstance.! !

!DClass methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/8/2013 14:01'!
name: aName 
	name := aName.
	! !

ClassType subclass: #EClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

EClass class
	instanceVariableNames: 'uniqueInstance'!

EClass class
	instanceVariableNames: 'uniqueInstance'!

!EClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:48'!
new
     uniqueInstance ifNil: [uniqueInstance := super new name:'EClass' ]. 
     ^ uniqueInstance.! !

!EClass methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/8/2013 14:03'!
name: aName 
	name := aName.
	! !

ClassType subclass: #NCClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

NCClass class
	instanceVariableNames: 'uniqueInstance'!

NCClass class
	instanceVariableNames: 'uniqueInstance'!

!NCClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:48'!
new
     uniqueInstance ifNil: [uniqueInstance := super new name:'NCClass' ]. 
     ^ uniqueInstance.! !

!NCClass methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/8/2013 14:04'!
name: aName 
	name := aName.
	! !

ClassType subclass: #OverallClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

OverallClass class
	instanceVariableNames: 'uniqueInstance'!

OverallClass class
	instanceVariableNames: 'uniqueInstance'!

!OverallClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:48'!
new
     uniqueInstance ifNil: [uniqueInstance := super new name:'Overall' ]. 
     ^ uniqueInstance.! !

!OverallClass methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/8/2013 14:04'!
name: aName 
	name := aName.
	! !

Object subclass: #ConcurrentType
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

ConcurrentType subclass: #ActiveMillitaryConcurrent
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

ActiveMillitaryConcurrent class
	instanceVariableNames: 'uniqueInstance'!

ActiveMillitaryConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!ActiveMillitaryConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:48'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := super new name:'ActiveMillitaryConcurrent']. 
     ^ uniqueInstance.! !

!ActiveMillitaryConcurrent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 20:19'!
name: aName
	name := aName! !

ConcurrentType subclass: #CollegiateConcurrent
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

CollegiateConcurrent class
	instanceVariableNames: 'uniqueInstance'!

CollegiateConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!CollegiateConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:49'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := super new name:'CollegiateConcurrent']. 
     ^ uniqueInstance.! !

!CollegiateConcurrent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 20:19'!
name: aName
	name := aName! !

!ConcurrentType methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:59'!
name
	^ name.! !

ConcurrentType subclass: #JuniorConcurrent
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

JuniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

JuniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!JuniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:49'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := super new name:'JuniorConcurrent']. 
     ^ uniqueInstance.! !

!JuniorConcurrent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 20:15'!
name: aName
	name := aName! !

ConcurrentType subclass: #LadyConcurrent
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

LadyConcurrent class
	instanceVariableNames: 'uniqueInstance'!

LadyConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!LadyConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:49'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := super new name:'LadyConcurrent']. 
     ^ uniqueInstance.! !

!LadyConcurrent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 20:19'!
name: aName
	name := aName! !

ConcurrentType subclass: #RetiredMillitaryConcurrent
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

RetiredMillitaryConcurrent class
	instanceVariableNames: 'uniqueInstance'!

RetiredMillitaryConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!RetiredMillitaryConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:49'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := super new name:'RetiredMillitaryConcurrent']. 
     ^ uniqueInstance.! !

!RetiredMillitaryConcurrent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 20:20'!
name: aName
	name := aName! !

ConcurrentType subclass: #SeniorConcurrent
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

SeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

SeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!SeniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:49'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := super new name:'SeniorConcurrent']. 
     ^ uniqueInstance.! !

!SeniorConcurrent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 20:17'!
name: aName
	name := aName! !

ConcurrentType subclass: #SubJuniorConcurrent
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

SubJuniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

SubJuniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!SubJuniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:49'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := super new name:'SubJuniorConcurrent']. 
     ^ uniqueInstance.! !

!SubJuniorConcurrent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 20:06'!
name: aName
	name := aName! !

ConcurrentType subclass: #SubSeniorConcurrent
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

SubSeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

SubSeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!SubSeniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:49'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := super new name:'SubSeniorConcurrent']. 
     ^ uniqueInstance.! !

!SubSeniorConcurrent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 20:17'!
name: aName
	name := aName! !

ConcurrentType subclass: #SubSubSeniorConcurrent
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

SubSubSeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

SubSubSeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!SubSubSeniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:49'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := super new name:'SubSubSeniorConcurrent']. 
     ^ uniqueInstance.! !

!SubSubSeniorConcurrent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 20:16'!
name: aName
	name := aName! !

ConcurrentType subclass: #TripleSubSeniorConcurrent
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

TripleSubSeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

TripleSubSeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!TripleSubSeniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:50'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := super new name:'TripleSubSeniorConcurrent']. 
     ^ uniqueInstance.! !

!TripleSubSeniorConcurrent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 20:16'!
name: aName
	name := aName! !

ConcurrentType subclass: #VeteranConcurrent
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

VeteranConcurrent class
	instanceVariableNames: 'uniqueInstance'!

VeteranConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!VeteranConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:50'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := super new name:'VeteranConcurrent']. 
     ^ uniqueInstance.! !

!VeteranConcurrent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 20:18'!
name: aName
	name := aName! !

Object subclass: #DatabaseWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!DatabaseWrapper methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 16:25'!
connect
	 ^ self subclassResponsibility.! !

!DatabaseWrapper methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 16:22'!
connectionFailed
	 ^ self subclassResponsibility.! !

!DatabaseWrapper methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 16:25'!
disconnect
	 ^ self subclassResponsibility.! !

!DatabaseWrapper methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 16:50'!
saveEvent: anEvent
	 ^ self subclassResponsibility.! !

!DatabaseWrapper methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 16:50'!
saveScore: aScore
	 ^ self subclassResponsibility.! !

!DatabaseWrapper methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 16:50'!
saveUser: aUser
	 ^ self subclassResponsibility.! !

Object subclass: #Event
	instanceVariableNames: 'name shooters eventType scores scoreFormat honors shootoffs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Event subclass: #CompositeEvent
	instanceVariableNames: 'events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!Event class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 18:02'!
newEventWithName: aName
	^ self new eventWithName: aName.! !

!Event class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 16:23'!
newEventWithName: aName andType: aType
	^ self new eventWithName: aName andType: aType.! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:21'!
addShooter: aShooter
	shooters add: aShooter.
	scores at: (aShooter name) put: (self getZeroScore).
	
	 ! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:23'!
createHonors
	self createHonorsFor: 1.! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/8/2013 13:55'!
createHonorsFor: aNumber
	"Creates the list of Honor objects given how many places will exist. This can be done once all shooters have been entered for an Event, but before all scores are entered for the event."
	|allClasses allConcurrents concurrents tempHonor tempShooters sortedShooters rankings rank tempCollection|
	
	allClasses := Collection new.
	allConcurrents := Collection new.
	tempHonor := Honor new.
	
	
	"find all present classes and concurrents among shooters"
	shooters do: [ :shooter |
		allClasses addIfNotPresent: (shooter classFor: self).
		concurrents := shooter concurrents .
		concurrents do: [ :concurrent | 
			allConcurrents addIfNotPresent: concurrent.
			 ]
		 ].
	
	"add an overall honor with all shooters"
	tempHonor = Honor newForEvent: self type: (Overall newWithAverage: 0)  numPositions: aNumber.
	tempHonor addShooters: shooters.
	honors add:  tempHonor.
	
	"for each class create a list of shooters and construct an honor for it"
	allClasses do: [ :class | 
		tempShooters := Collection new.
		
		shooters do: [ :shooter | 
			((shooter classFor: self) == class) ifTrue: (tempShooters add: shooter).
			 ].
		
		tempHonor = Honor newForEvent: self type: class numPositions: aNumber.
		tempHonor addShooters: tempShooters.
		honors add: tempHonor. 
		
		].
	
	"for each concurrent create a list of shooters and construct an honor for it"
	allConcurrents do: [ :concurrent | 
		tempShooters := Collection new.
		
		shooters do: [ :shooter | 
			((shooter concurrent) == concurrent ) ifTrue: (tempShooters add: shooter).
			 ].
		
		tempHonor = Honor newForEvent: self type: concurrent  numPositions: aNumber.
		tempHonor addShooters: tempShooters.
		honors add: tempHonor. 
		
		].
	.
	
	" now generate the rankings for each honor"
	
	honors do: [ :honor|
		sortedShooters := (honor shooters) asSortedCollection: [ :x :y | (self getTotalScoreFor: x) > (self getTotalScoreFor: y)  ]. 
		rankings := Dictionary new.
		rank :=1.
		tempCollection := Collection new.
		tempCollection add: (sortedShooters at: 0 ).
		
		
		1 to:  ((sortedShooters size) -1)  do: [ :i|
			((self getTotalScoreFor: i) = (self getTotalScoreFor: (i-1))) 
				ifTrue: [
					tempCollection add: (sortedShooters at: i )]
				ifFalse: [ 
					rankings at: rank put: tempCollection.
					rank := rank +1.
					tempCollection := Collection new.
					tempCollection add: (sortedShooters at: i ).
				].
			 ].
		
		honor rankings: rankings.
	]. ! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 16:24'!
eventType 
	^eventType.! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 16:06'!
eventWithName: aName andType: aType
	name:= aName.
	shooters := OrderedCollection new.
	scores := Dictionary new. "key is the name of a shooter. Value is a collection of scores."
	scoreFormat := OrderedCollection new add: 25; add: 25; add:25 ; add: 25. "this is just a collection. Length of the collection specifies the number of rounds. Value of each element is the maximum score that can be entered for each round"
	shootoffs  := OrderedCollection new.
	honors := OrderedCollection new.
	eventType := aType.
	
	! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/8/2013 13:54'!
generateHonors
	"I attempt to assign the winner of each already created honor. If there are ties, I generate shootoffs."
! !

!Event methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/8/2013 15:43'!
generateHonors: aNumber 
	"I attempt to assign the winner of each already created honor. If there are ties, I generate shootoffs."
	|sortedShooters rankings rank tempCollection sizeoftemp total |
	
	honors do: [ :honor|
		sortedShooters := (honor shooters) asSortedCollection: [ :x :y | (self getTotalScoreFor: x) > (self getTotalScoreFor: y)  ]. 
		rankings := Dictionary new.
		rank :=1.
		tempCollection := Collection new.
		tempCollection add: (sortedShooters at: 0 ).
		
		
		1 to:  ((sortedShooters size) -1)  do: [ :i|
			((self getTotalScoreFor: i) = (self getTotalScoreFor: (i-1))) 
				ifTrue: [
					tempCollection add: (sortedShooters at: i )]
				ifFalse: [ 
					rankings at: rank put: tempCollection.
					rank := rank +1.
					tempCollection := Collection new.
					tempCollection add: (sortedShooters at: i ).
				].
			 ].
		
		honor rankings: rankings.
		total:=0.
		1 to: (aNumber) do: [ :i|
			tempCollection = honor rankings at: i.
			sizeoftemp := tempCollection size .
		      ((sizeoftemp>1)&(total<aNumber ))
		      ifTrue: [self generateShootOffFor:honor Between:tempCollection.
			total:=total+sizeoftemp.
			]
		      ifFalse: [total:=total+1]
			 ]
 		
	]. ! !

!Event methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/8/2013 21:40'!
generateShootOffFor: anHonor Between: someShooters
	"Generates a single shootoff for a particular honor between a collection of shooters. It adds the shootoff to the Event's Collection of shootoffs. "
       (self resolvedWith: someShooters =true)
       ifTrue:[self generateHonors]
	 
	! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/7/2013 16:02'!
getTotalScoreFor: aShooter
	^ (scores at: (aShooter name)) sum.! !

!Event methodsFor: 'helper methods' stamp: 'BiplabDeka 7/5/2013 14:20'!
getZeroScore
	" return a collection of zeros that is the same length as the score format"
	|zeroscore|
	zeroscore := Collection new.
	scoreFormat do: [ :score | zeroscore add: 0].
	
	^ zeroscore.
	! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:27'!
honors 
	^honors.! !

!Event methodsFor: 'helper methods' stamp: 'BiplabDeka 7/5/2013 14:14'!
isScoreValid: aScore
	|bool|
	bool := true.
	( aScore length == scoreFormat length ) ifFalse:  [bool := false] ifTrue: [
		aScore with: scoreFormat collect: [:score :bound | (score > bound) ifTrue: [bool:= false]]
		].
	
	

	^bool! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:22'!
name 
	^name.! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 16:15'!
removeNC
	"process all NC class shooters and put them in appropriate class"
	.! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 16:10'!
removeShooter: aShooter
	shooters remove:  aShooter.
	scores remove:  (aShooter name) .
	
	 ! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:15'!
setScore: aScore for: aShooter
	(self isScoreValid: aScore) ifTrue: [ 
		scores at: (aShooter name ) put: aScore.
	]! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:22'!
shooters
	^shooters.! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:27'!
shootoffs
	^shootoffs.! !

Event subclass: #RealEvent
	instanceVariableNames: 'eventType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Object subclass: #EventType
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

EventType subclass: #Bore410
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Bore410 class
	instanceVariableNames: 'uniqueInstance'!

Bore410 class
	instanceVariableNames: 'uniqueInstance'!

!Bore410 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:47'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := super new name:'Bore410']. 
     ^ uniqueInstance.! !

!Bore410 methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 20:25'!
name: aName
	name := aName.! !

EventType subclass: #Doubles
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Doubles class
	instanceVariableNames: 'uniqueInstance'!

Doubles class
	instanceVariableNames: 'uniqueInstance'!

!Doubles class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:47'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := super new name:'Doubles']. 
     ^ uniqueInstance.! !

!Doubles methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 20:25'!
name: aName
	name := aName.! !

!EventType methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 20:22'!
name
	^name.! !

!EventType methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/3/2013 16:21'!
name: aSymbol
	name := aSymbol.! !

EventType subclass: #Gauge12
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Gauge12 class
	instanceVariableNames: 'uniqueInstance'!

Gauge12 class
	instanceVariableNames: 'uniqueInstance'!

!Gauge12 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 11:25'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := super new name:'Gauge12']. 
     ^ uniqueInstance.! !

!Gauge12 methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 20:24'!
name: aName
	name := aName.! !

EventType subclass: #Gauge20
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Gauge20 class
	instanceVariableNames: 'uniqueInstance'!

Gauge20 class
	instanceVariableNames: 'uniqueInstance'!

!Gauge20 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:47'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := super new name:'Gauge20']. 
     ^ uniqueInstance.! !

!Gauge20 methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 20:24'!
name: aName
	name := aName.! !

EventType subclass: #Gauge28
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Gauge28 class
	instanceVariableNames: 'uniqueInstance'!

Gauge28 class
	instanceVariableNames: 'uniqueInstance'!

!Gauge28 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 15:47'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := super new name:'Gauge28']. 
     ^ uniqueInstance.! !

!Gauge28 methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 20:24'!
name: aName
	name := aName.! !

Object subclass: #Honor
	instanceVariableNames: 'event type shooters numPositions winners rankings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!Honor class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/7/2013 14:36'!
newForEvent: anEvent type: aType numPositions: aNumber 	
	^ self new event: anEvent type: aType numPositions: aNumber 	 ! !

!Honor methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/7/2013 14:47'!
addShooters: aCollection
	aCollection do: [ :shooter |
		shooters addIfNotPresent: shooter.
		 ].! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:48'!
event
	^event.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 16:06'!
event: anEvent type: aType numPositions: aNumber
	event := anEvent.
	type := aType.
	numPositions := aNumber.
	shooters := OrderedCollection new.
	winners := OrderedCollection new.
	rankings := Dictionary new.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:49'!
positions 
	^positions.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/7/2013 16:35'!
rankings 
	^rankings.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/7/2013 16:35'!
rankings: aDictionary 
	rankings := aDictionary .! !

!Honor methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/7/2013 16:00'!
shooters
	^shooters.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:48'!
type 
	^type.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:49'!
winners 
	^winners.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/7/2013 16:10'!
winners: aList 
	winners := aList.! !

Object subclass: #Shoot
	instanceVariableNames: 'name shooters events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!Shoot class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:54'!
newShootWithName: aName 	
	^ self new shootWithName: aName.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:56'!
addEvent: anEvent
	events add: anEvent.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:56'!
addShooter: aShooter 
	shooters add: aShooter.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 16:07'!
shootWithName: aName
	name:= aName.
	shooters := OrderedCollection new.
	events := OrderedCollection new.! !

Object subclass: #Shooter
	instanceVariableNames: 'uuid firstName lastName middleName dob membershipNumber classifications averages concurrents address phone email'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!Shooter class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:32'!
newShooterFirst: first middle: middle last: last
	^ self new firstName: first middleName: middle lastName: last.! !

!Shooter methodsFor: 'concurrent related' stamp: 'BiplabDeka 7/5/2013 14:59'!
addConcurrent: aConcurrent 
	concurrents add: aConcurrent name.
! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:14'!
address
	^ address.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/8/2013 14:09'!
averageFor: anEventType
	^  averages at: anEventType.! !

!Shooter methodsFor: 'concurrent related' stamp: 'BiplabDeka 7/5/2013 14:59'!
belongsToConcurrent: aConcurrent 
	^ concurrents contains: (aConcurrent name).
! !

!Shooter methodsFor: 'class related' stamp: 'BiplabDeka 7/8/2013 14:10'!
classFor: anEventType
	^ classifications at:anEventType .! !

!Shooter methodsFor: 'class related' stamp: 'BiplabDeka 7/5/2013 16:27'!
concurrents
^ concurrents .! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:34'!
dob: aDate  	
	dob := aDate.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:14'!
email  
	^ email.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 16:07'!
firstName: first middleName: middle lastName: last
	firstName:= first.
	middleName:= middle .
	lastName:= last.
	dob:= Date newDay: 1 month:1  year:1900.
	address:='your address'.
	membershipNumber:=0.
	uuid:= first+'_'+middle+'_'+last.
	classifications := Dictionary new. " key is event type. value is a Class type."
	averages := Dictionary new. " key is event type. value is a number."
	concurrents := OrderedCollection new. "list of concurrent objects stored as names"
	 phone := 1112223333.
	email := 'yourname@example.com'
	 ! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/8/2013 14:10'!
getClass: anEventType 
	" return a class is event is present. else return a NC with avergae zero"
	^ classifications at: (anEventType) ifAbsent: (ClassType newNCClass: 0) .! !

!Shooter methodsFor: 'class related' stamp: 'BiplabDeka 7/4/2013 17:33'!
lastName: last 	
	lastName := last.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:35'!
membershipNumber: aNumber  	
	membershipNumber := aNumber.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:33'!
middleName: middle 	
	middleName := middle.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:12'!
name
	^name.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:14'!
phone 
	^ phone.! !

!Shooter methodsFor: 'class related' stamp: 'BiplabDeka 7/8/2013 14:34'!
setClass: aClass forEvent: anEventType withAverage: anAverage
	
	classifications at: (anEventType ) put: (aClass) .
	averages at: (anEventType ) put: anAverage.! !

Object subclass: #Shootoff
	instanceVariableNames: 'shooters resolved honor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!Shootoff methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:40'!
honor 
	^honor.! !

!Shootoff methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:40'!
resolved
	^resolved.! !

!Shootoff methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/8/2013 15:50'!
resolvedWith:  someShooters 
	shooters := someShooters.
	resolved := true.
	"AND SOME MORE THINGS, such as calling honor to assign the winners, etc."
	^true! !

!Shootoff methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:40'!
shooters
	^shooters.! !
